package ru.bitheaven.createairfabric.mixin;

import com.llamalad7.mixinextras.injector.ModifyExpressionValue;
import earth.terrarium.adastra.common.items.armor.NetheriteSpaceSuitItem;
import earth.terrarium.adastra.common.tags.ModItemTags;
import net.minecraft.class_1304;
import net.minecraft.class_1309;
import net.minecraft.class_3218;
import earth.terrarium.adastra.common.systems.TemperatureApiImpl;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;

@Mixin(TemperatureApiImpl.class)
public abstract class EntityTemperatureSystemMixin {
    @ModifyExpressionValue(at = @At(value = "INVOKE", target = "Learth/terrarium/adastra/api/events/AdAstraEvents$HotTemperatureTickEvent;fire(Lnet/minecraft/server/level/ServerLevel;Lnet/minecraft/world/entity/LivingEntity;)Z"),
            method = "entityTick(Lnet/minecraft/server/level/ServerLevel;Lnet/minecraft/world/entity/LivingEntity;)V")
    private boolean redirectTemperatureTick(boolean original, class_3218 level, class_1309 entity) {
        boolean createNetherite = true;
        createNetherite &= entity.method_6118(class_1304.field_6169).method_7909().method_24358();
        createNetherite &= entity.method_6118(class_1304.field_6174).method_7909().method_24358();
        createNetherite &= entity.method_6118(class_1304.field_6172).method_31573(ModItemTags.HEAT_RESISTANT_ARMOR)
                || entity.method_6118(class_1304.field_6172).method_7909() instanceof NetheriteSpaceSuitItem
                || entity.method_6118(class_1304.field_6172).method_7909().method_24358();
        createNetherite &= entity.method_6118(class_1304.field_6166).method_31573(ModItemTags.HEAT_RESISTANT_ARMOR)
                || entity.method_6118(class_1304.field_6166).method_7909() instanceof NetheriteSpaceSuitItem
                || entity.method_6118(class_1304.field_6166).method_7909().method_24358();

        return original && !createNetherite;
    }
}
