package ru.bitheaven.createairfabric.mixin;

import com.llamalad7.mixinextras.injector.ModifyExpressionValue;
import com.simibubi.create.content.equipment.armor.RemainingAirOverlay;
import net.minecraft.class_310;
import net.minecraft.class_746;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import ru.bitheaven.createairfabric.CreateAirFabric;

@Mixin(RemainingAirOverlay.class)
public class RemainingAirOverlayMixin {
    /**
     * Activate UI "if in water or lava" -> "if in water or bad air or lava"
     */
    @ModifyExpressionValue(at = @At(value = "INVOKE", target = "Lnet/minecraft/client/player/LocalPlayer;isEyeInFluid(Lnet/minecraft/tags/TagKey;)Z"),
            method = "render(Lnet/minecraft/client/gui/GuiGraphics;II)V")
    private static boolean redirectRender(boolean original) {
        class_310 mc = class_310.method_1551();
        class_746 player = mc.field_1724;
        return original || !CreateAirFabric.isOxygen(player);
    }
}
